#line 1 "Specio/Constraint/ObjectDoes.pm"
package Specio::Constraint::ObjectDoes;

use strict;
use warnings;

our $VERSION = '0.31';

use B ();
use Role::Tiny::With;
use Scalar::Util ();
use Specio::Library::Builtins;
use Specio::OO;

use Specio::Constraint::Role::DoesType;
with 'Specio::Constraint::Role::DoesType';

{
    my $Object = t('Object');
    sub _build_parent {$Object}
}

{
    my $_inline_generator = sub {
        my $self = shift;
        my $val  = shift;

        return sprintf( <<'EOF', ($val) x 3, B::perlstring( $self->role ) );
(
    Scalar::Util::blessed( %s )
    &&
    %s->can('does')
    &&
    %s->does(%s)
)
EOF
    };

    sub _build_inline_generator {$_inline_generator}
}

__PACKAGE__->_ooify;

1;

# ABSTRACT: A class for constraints which require an object that does a specific role

__END__

#line 117
